# MAIN IMPORTS ================================================================================================================================================ #
import es
import keyvalues
import os
import playerlib
import popuplib
import time
import psyco
import langlib
psyco.full()
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')
block  = es.import_addon('sam/base/pcontrol')
bans   = es.import_addon('sam/base/pcontrol/ban')

# VARIABLES
temp = {}

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### POPUPS ###
	func.popupDelete('banList')
	func.popupDelete('banPage')
	
# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def moduleAction(userid, msg=1):
	temp[userid] = {}
	if os.path.isfile(bans.db_dir):
		banned = [x for x in keyvalues.getKeyGroup(bans.db) if bans.isBanned(x)]
		if len(banned) > 0:
			func.popupDelete('banList')
			popup = popuplib.easymenu('banList', None, banPage)
			popup.c_beginsep = func.pline
			popup.c_pagesep  = func.pline
			popup.settitle('%s | SAM %s\n \n :: %s ' % (func.menutitle, es.ServerVar(func.version), func.lang_titles('choose_player')))
			for ban in banned:
				player = bans.getBanned(ban)
				popup.addoption(player, '%s [%s]' % (player['name'], func.lang_pcontrol(player['length'])))
			popup.submenu(10, 'pcontrol')
			popup.send(userid)
		else:
			if msg == 1: func.hudhint(userid, func.lang_pcontrol('unban_no_players_banned'), func.admins_hudtag)
			block.modulePopup(userid)
	else:
		if msg == 1: func.hudhint(userid, func.lang_pcontrol('unban_no_players_banned'), func.admins_hudtag)
		block.modulePopup(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def banPage(userid, target, popup):
	temp[userid]['target'] = target['steamid']
	if target['length'] == 'perm': string = ' # %s: %s' % (func.lang_word('length'), func.lang_pcontrol('perm'))
	else: string = ' # %s: %s' % (func.lang_word('length'), func.lang_pcontrol(target['length']))
	func.popupDelete('banPage')
	popup = popuplib.create('banPage')
	popup.addline('%s | SAM %s' % (func.menutitle, es.ServerVar(func.version)))
	popup.addline('\n \n :: %s' % func.lang_titles('pcontrol_unban'))
	popup.addline(func.pline)
	popup.addline(' # %s: %s' % (func.lang_word('name'),target['name']))
	popup.addline(' # ID: %s' % (target['steamid']))
	popup.addline(string)
	popup.addline(' # Ban Admin: %s' % target['admin'])
	popup.addline(' # %s: %s' % (func.lang_word('reason'), target['reason']))
	popup.addline(' \n%s' % func.lang_pcontrol('unban_confirmation'))
	popup.addline('->1. %s' % func.lang_word('yes'))
	popup.addline('->2. %s' % func.lang_word('no'))
	popup.addline(func.pline)
	popup.addline('0. %s' % func.lang_word('cancel'))
	popup.menuselect = banPageChoice
	popup.send(userid)

# ------------------------------------------------------------------------------------------------------------------------------------------------------------- #
def banPageChoice(userid, choice, popup):
	func.popupDelete('banPage')
	if choice == 1:
		if userid in temp and len(temp[userid]) == 1:
			func.hudhint(userid, func.lang_pcontrol('unban_target', bans.getBanned(temp[userid]['target'])), func.admins_hudtag)
			es.keydelete(bans.db, temp[userid]['target'])
			es.keygroupsave(bans.db, func.dbfiles)
			del temp[userid]
	moduleAction(userid)

# ============================================================================================================================================================= #
