# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import os
import random
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')
base   = es.import_addon('sam/base')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Round End Sounds'
addon.basename = 'res'
addon.status   = 0
addon.version  = '1.0.beta'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES
temp = {'last':0}

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 0)

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def round_end(ev):
	if len(getSounds()) > 0:
		sound = random.choice(getSounds())
		while temp['last'] == sound: sound = random.choice(getSounds())
		else:
			func.playall('sam_sounds/round_end_sounds/' + sound)
			temp['last'] = sound

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def getSounds(): return [sound for sound in os.listdir(func.dir_sounds + 'round_end_sounds') if sound.endswith('.mp3') or sound.endswith('.wav')]

# ============================================================================================================================================================= #